;           !!! AGGIORNARE LA DESCRIZIONE DELLA FUNZIONE READPOS !!!
;           ??? SI PUO' USARE LO STACK NEL TSR ???

        name      ROT13
        title     Driver Rotore Satellitare Autarchico
;     Questo driver e' molto simile al ROT9.COM, scritto a sua volta a partire
;     dal ROTORDUM.ASM (ovvero il DummyKCT).
;     Invia sulla COMn (non impostabile, bisogna riassemblare...)
;     i valori relativi a azimuth e elevazione con un semplice formato:
;     <azim flag> <azim val> <elev flag> <elev val>
;     con:  <azim flag> = e0h  e  <elev flag> = eeh
;     I due valori sono divisi per due, cos  possibile trasmetterli
;     in un solo byte: la risoluzione di 2 si ritiene per ora sufficiente.
;
;
;                 Prima versione messa a punto l'11/11/1995
;                 Modifiche:
;                       24/02/1996 prova con il vero rotore (solo az)
;                       10/5/96 messo a punto il ROT9.ASM
;                       23/2/97 iniziata la riscrittura del driver definitivo
;                               (ROT11.ASM)
;                       25/2/97 nuovo protocollo con riletture dal rotore
;                               (ROT13.ASM)


;-----------------------------------------------------------------------------
; Inizializzazioni necessarie per il file .COM (e TSR)
;-----------------------------------------------------------------------------


_TEXT	segment word public 'CODE'

      ORG     100h                    ; .COM

      assume  cs:_TEXT, ds:_TEXT, es:_TEXT, ss:_TEXT

;-----------------------------------------------------------------------------
; Lanciando questo .COM si va alla routine di installazione, poi una parte del
; programma, cioe' quella da <isr:> a <endisr:> viene lasciata in memoria e
; costituisce le routine di servizio dell'interrupt 63 (isr).
;-----------------------------------------------------------------------------
start:
      jmp install

enabled     db    1     ; Abilitazione: non ne ho capito l'utilita' ma si lascia
                        ; per compatibilita' con il dummyKCT, en=1, dis=0
azim        dw    0     ; Valore attuale di azimuth
elev        dw    0     ; Valore attuale di elevazione
oldazim     dw    0     ; Valori della chiamata precedente per
oldelev     dw    0     ; trasmettere solo se c'e' stata una variazione
flip        db    0     ; Arrovesciamento antenne per spostare il punto morto a
                        ; sud anziche a nord in modo da non dover fare tutto il
                        ; giro a meta' di certi passaggi

backaz      dw    0     ; Valore attuale dell'azimuth ricevuto dal rotore e che
                        ; questo driver passa al programma chiamante tramite la
                        ; funzione Readpos
backel      dw    0     ; Valore attuale dell'elevazio ne ricevuto dal rotore
                        ; e che questo driver passa al programma chiamante
                        ; tramite la funzione Readpos

status      db    0     ; Stato del rotore per la funzione Readstat

RETRREP     equ   2     ; numero di ritrasmissioni sia per az che el
azrep       db    0     ; ripetizioni della trasmissione dell'azimuth
elrep       db    0     ; ripetizioni della trasmissione dell'elevazione

COM         equ   3     ; COM1 = 0, COM2 = 1, COM3 = 2, COM4 =3
baseaddr    dw    0     ; indirizzo base uart COMn
bauddiv     equ   0ch   ; 0x0c corrisponde a 9600 (115200/9600=12)

sld         db    0     ; Rallentamento dei cicli di lettura della Readpos
SLDN        equ   20    ; Numero di chiamate alla Readpos saltate

;-----------------------------------------------------------------------------
; Interrupt Service Routine
;-----------------------------------------------------------------------------

      assume  ds:nothing, es:nothing, ss:nothing

isr:  jmp     servsel

      org     isr + 10
      db      "RotorDRV"      ; Firma, affinche il programma chiamante
                              ; riconosca che il driver e' presente (vedi
                              ; l' MRC.C. Questa firma si deve trovare 10
                              ; (decimale) byte dopo l'inizio della isr

servsel     proc   near       ; Scelta della routine per svolgere la
                              ; funzione richiesta in base a AH
      cmp   ah,0
      je    readstat
      cmp   ah,3
      je    readpos
      cmp   ah,4
      je    i_setpos
      cmp   ah,9
      je    enable
      cmp   ah,40h
      je    flipctrl
      cmp   ah,41h
      je    flipread
      cmp   ah,0ffh
      call  unload
      iret
servsel     endp

;-----------------------------------------------------------------------------
; Funzioni chiamate dall'interrupt
;-----------------------------------------------------------------------------


;-----------------------------------------------------------------------------
; Readstat: restituisce lo stato del driver, ovvero del rotore, ma per ora non
;           e' realmente funzionante, anche perche' non si conosce il
;           significato dei codici di ritorno. L'unica cosa che ho
;           scoperto e' che l'Instant Track dice che il rotore e' disabilitato
;           se questa funzione ritorna ffh, altrimenti funziona; per
;           compatibilita' con il DummyKCT fi fa ritornare 00h.
;
;     Ingresso:
;           AH=0
;     Uscita:
;           AL=0 (vedi sopra)
;-----------------------------------------------------------------------------

readstat    proc  near
      mov   al,cs:status
      iret
readstat    endp


;-----------------------------------------------------------------------------
; Enable:   imposta il flag di abilitazione o meno di questo driver, vedi le
;           note della funzione Readstat.
;     Ingresso:
;           AH=9
;           AL=<enable>  1=enable, 0=disable
;     Uscita:
;           ---
;-----------------------------------------------------------------------------

enable      proc    near
      mov     enabled,al
      iret
enable      endp


;-----------------------------------------------------------------------------
; Flipctrl: imposta o meno la modalita flip. Questa modalita' non e' ancora
;           chiara, soprattutto in relazione all'uso che ne deve fare la
;           Control-Box, percio non e' da considerarsi stabile.
;           Il valore AH=40 per questa funzione l'ho preso senza sapere se era
;           libero o meno, ma non sembra ci siano conflitti con l'Instant Track
;           o l' Orbitdrv.
;     Ingresso:
;           AH=40
;           AL=<flip>  1=flip, 0=no flip
;     Uscita:
;           ---
;-----------------------------------------------------------------------------

flipctrl    proc  near
      mov   flip,al
      iret
flipctrl    endp


;-----------------------------------------------------------------------------
; Flipread: restituisce lo stato della modalita' flip, vedi descrizione funzione
;           Flipctrl.
;           Il valore AH=40 per questa funzione l'ho preso senza sapere se era
;           libero o meno, ma non sembra ci siano conflitti con l'Instant Track
;           o l' Orbitdrv.
;
;     Ingresso:
;           AH=41
;     Uscita:
;           AL=<flip>  1=flip, 0=no flip
;-----------------------------------------------------------------------------

flipread    proc  near
      mov al,flip
      iret
flipread    endp



;-----------------------------------------------------------------------------
; Mi sarebbe piaciuto mettere le routine in ordine di AH, ma la Setpos e' cosi'
; lunga che il salto near non ce la fa! Addirittura bisogna fare questo
; intersalto.
;-----------------------------------------------------------------------------

i_setpos    proc  near
      jmp   setpos

i_setpos    endp

;-----------------------------------------------------------------------------
; Readpos:  restituisce l'ultima posizione trasmessa al rotore (in seguto
;           dovra' essere l'ultima posizione che il rotore ha ritrasmesso
;           indietro, ma per ora il protocollo non e' cosi' raffinato)
;           !!!   Ho il sospetto che nell'Instant Track i dati vengano letti
;                 dai registri AX e BX anziche' CX e DX !!!
;           In seguito all'aggiornamento del valore dell'elevazione l'Instant
;           Track scrive "disabled" sulla posizione dell'antenna, ma subito dopo
;           ricompare la posizione giusta (?).
;
;     Ingresso:
;           AH=3
;     Uscita:
;           DX=<azimuth>      ?
;           CX=<elevazione>   ?
;-----------------------------------------------------------------------------

readpos     proc  near
      cmp   cs:sld,0          ; Salta SLDN letture altrimenti il PIC del
      jz    rp                ; rotore viene perturbato troppo dalla continua
      dec   cs:sld            ; gestione del canale seriale
                              ; E quando si salta la lettura il valore
                              ; restituito e' oldazim e oldelev
      mov   ax,cs:oldelev
      sal   ax,1        ; oldelev e' diviso per due, va rimoltiplicato
      mov   cx,ax
      mov   bx,cs:oldazim
      sal   bx,1        ; oldazim e' diviso per due, va rimoltiplicato
      mov   dx,bx
      iret

rp:
      mov   cs:sld,SLDN
; svuota il buffer di ricezione dell'uart
      call  rx_uart_spool

; invia la richiesta del valore attuale dell'azimuth
      mov   al,0e1h
      call  txchar
      mov   al,0e8h
      call  txchar

; aspetta la risposta in relazione al comando backAZ
      call  rxchar
      cmp   al,0e0h
      jne   proterr
      call  rxchar
      mov   ah,00
      mov   cs:backaz,ax
      mov   cs:status,0

; svuota il buffer di ricezione dell'uart
      call  rx_uart_spool

; invia la richiesta del valore attuale dell'elevazione
      mov   al,0e1h
      call  txchar
      mov   al,0e9h
      call  txchar

; aspetta la risposta in relazione al comando backEL
      call  rxchar
      cmp   al,0eeh
      jne   proterr
      call  rxchar
      mov   ah,00h
      mov   cs:backel,ax
      mov   cs:status,0

; passa i valori nei registri cx e dx
      mov   ax,cs:backel
      sal   ax,1              ; vanno rimoltiplicati per due
      mov   cx,ax
      mov   bx,cs:backaz
      sal   bx,1              ; vanno rimoltiplicati per due
      mov   dx,bx
      iret

proterr:                      ; Se c'e' un errore di protocollo in ricezione
      mov   cs:status,0ffh    ; (NOTA: non un errore di ricezione seriale!)
      mov   dx,cs:backaz      ; non e' facile sapere cosa succede, per ora si
      mov   cx,cs:backel      ; mette a ff lo stato della funzione Readstat e
      iret                    ; si ritorna l'ultima posizione ritrasmessa dal
                              ; rotore.

readpos     endp




;-----------------------------------------------------------------------------
; Setpos:   trasmette la posizione al rotore solo se questa e' cambiata
;           rispetto all'interrupt precedente. Il DummyKCT dice che i valori
;           validi sono "(0-359, binary)" per l'azimuth, e
;           "(-90 to 269, signed binary)" per l'elevazione, inoltre c'e' la
;           "Note: If either value is invalid the entire command will be
;           ignored.".
;           In effetti questo driver usa solo valori 0-359 per l'azimuth e 0-180
;           per l'elevazione (0-90 o 90-180 se flip) e se l'elevazione e'
;           negativa non trasmette nulla.
;           Ciascun dato, azimuth e elevazione, viene ritrasmesso RETRREP volte
;           per essere sicuri che il rotore lo riceva.
;
;     Ingresso:
;           AH=4
;           DX=<azimuth>
;           CX=<elevazione>
;     Uscita:
;           ---
;-----------------------------------------------------------------------------

setpos      proc  near
      jmp   sp1
asp_end:
      iret
sp1:
      cmp   enabled,0       ; se il driver e' disabilitato esci
      je    asp_end

      mov   cs:azim,dx
      mov   cs:elev,cx
      test  cx,8000h      ;se elev<0 o elev>180 non trasmettere nulla
      jnz   asp_end
      cmp   cx,00b4h
      jg    asp_end

      sar   dx,1              ; sia azim che elev vengono divisi per
      sar   cx,1              ; due cosi' basta un byte per trasmetterli
                              ; (risoluzione di 2 gradi)

      cmp   flip,0
      jz    save
      mov   bx,00b4h
      sub   bx,dx
      mov   dx,bx
      mov   bx,005ah
      sub   bx,cx
      mov   cx,bx

save:
      cmp   cs:oldazim,dx     ; se l'az non e' cambiato non trasmettere
      jne   sendazf
      cmp   cs:azrep,0        ; se le ripetizioni sono state fatte tutte
      je    testel            ; non trasmettere l'azimuth
      dec   cs:azrep          ; altrimenti decrementa le ripetizioni da fare
      jmp   sendaz            ; e trasmetti

sendazf:
      mov   cs:azrep,RETRREP  ; questa e' la prima volta che si trasmette un
                              ; nuovo valore, quindi si deve inizializzare il
                              ; contatore delle ripetizioni di ritrasmissione
sendaz:
      push dx                 ; dx contiene azim
      mov   cs:oldazim,dx     ; salva il valore di az per la prossima chiamata

      mov   dx,[baseaddr]     ; aspetta che il buffer di trasmissione dell'uart
      add   dx,5              ; sia vuoto
txfree1:
      in    al,dx
      test  al,20h
      jz    txfree1
      mov   dx,[baseaddr]     ; trasmetti il flag dell'azimuth
      mov   al,0e0h
      out   dx,al
      mov   dx,[baseaddr]     ; aspetta che il buffer di trasmissione dell'uart
      add   dx,5              ; sia vuoto
txfree2:
      in    al,dx
      test  al,20h
      jz    txfree2
      pop   dx                ; recupera azim
      mov   al,dl             ; trasmetti il valore di azimuth (diviso due)
      mov   dx,[baseaddr]
      out   dx,al

testel:
      cmp   cs:oldelev,cx     ; se l'elevazione non e' cambiata non trasmettere
      jne   sendelf

      cmp   cs:elrep,0        ; se le ripetizioni sono state fatte tutte
      je    sp_end            ; non trasmettere l'elevazione
      dec   cs:elrep          ; altrimenti decrementa le ripetizioni da fare
      jmp   sendel            ; e trasmetti

sendelf:
      mov   cs:elrep,RETRREP  ; questa e' la prima volta che si trasmette un
                              ; nuovo valore, quindi si deve inizializzare il
                              ; contatore delle ripetizioni di ritrasmissione


      push      dx                ; Ritardo per dare tempo al PIC
      push      cx                ; di ricevere l'eventuale dato
      mov       ah,86h            ; dell'elevazione prima di dover
      mov       cx,0000h          ; gestire un'altro suo interrupt
      mov       dx,1388h          ; (porta seriale in ricezione).
      int       15h               ; Sono circa 5ms, forse troppi, e
      pop       cx                ; non e' possibile che il PIC abbia
      pop       dx                ; tutta questa latenza...

sendel:
      push cx                 ; cx contiene azim
      mov   cs:oldelev,cx     ; salva il valore di el per la prossima chiamata

      mov   dx,[baseaddr]     ; aspetta che il buffer di trasmissione dell'uart
      add   dx,5              ; sia vuoto
txfree3:
      in    al,dx
      test  al,20h
      jz    txfree3
      mov   dx,[baseaddr]     ; trasmetti il flag dell'elevazione
      mov   al,0eeh
      out   dx,al
      mov   dx,[baseaddr]     ; aspetta che il buffer di trasmissione dell'uart
      add   dx,5              ; sia vuoto
txfree4:
      in    al,dx
      test  al,20h
      jz    txfree4
      pop   cx                ; recupera elev (superfluo perche' cx non si usa)
      mov   al,cl             ; trasmetti il valore di elevazione (diviso due)
      mov   dx,[baseaddr]
      out   dx,al
sp_end:     iret

setpos      endp


;-----------------------------------------------------------------------------
; Rxchar: ricezione di un carattere dall'uart; aspetta un carattere
; indefinitivamente e lo restituisce, ma non controlla gli eventuali errori
; di ricezione. Poi bisognera' fare un bel timeout!
;     Ingresso:
;           ---
;     Uscita:
;           AL=<rxchar>
;-----------------------------------------------------------------------------
rxchar      proc  near
      mov   dx,cs:[baseaddr]
      add   dx,5
waitrx:
      in    al,dx
      test  al,1
      jz    waitrx
      mov   dx,cs:[baseaddr]
      in    al,dx
      ret
rxchar      endp


;-----------------------------------------------------------------------------
; Txchar:   trasmissione di un carattere via uart; aspetta che il buffer di
;           trasmissione sia vuoto ma non si controllano gli handshake
;
;     Ingresso:
;           AL=<txchar>
;     Uscita:
;           ---
;-----------------------------------------------------------------------------
txchar      proc  near

      push  ax
      mov   dx,[baseaddr]     ; aspetta che il buffer di trasmissione dell'uart
      add   dx,5              ; sia vuoto
txfree:
      in    al,dx
      test  al,20h
      jz    txfree
      mov   dx,[baseaddr]     ; trasmetti il flag dell'elevazione
      pop   ax
      out   dx,al
      ret
txchar      endp


;-----------------------------------------------------------------------------
; Rx_uart_spool:  svouta il buffer (3 caratteri) di ricezione dell'uart,
;                 per ora si fa cosi' affinche' la Readpos non dia errori di
;                 protocollo se il buffer fosse pieno; in seguito la ricezione
;                 via uart dovra' essere tratta da una routine di interrupt che
;                 provvedera' ad aggiornare, fra le altre cose, backaz e backel.
;                 In questo modo non ci dovrebbero essere problemi di blocco se
;                 il rotore non risponde.
;     Ingresso:
;           ---
;     Uscita:
;           ---
;-----------------------------------------------------------------------------

rx_uart_spool     proc  near
waitrx2:
      mov   dx,cs:[baseaddr]
      add   dx,5
      in    al,dx
      test  al,1
      jz    endspool
      mov   dx,cs:[baseaddr]
      in    al,dx
      jmp waitrx2
endspool:
      ret
rx_uart_spool     endp


;-----------------------------------------------------------------------------
; Unload:   Questa routine, chiamata attraverso l'INT63 con AH=0xff, rimuove
;           l'INT63 e termina il programma, rilasciando la memoria al DOS.
;           Per ogni ulteriore informazione consultare le varie funzioni
;           dell'INT21 del DOS.
;-----------------------------------------------------------------------------

unload      proc  near

      xor   ax,ax             ; DS:DX = 0000:0000 che dovrebbe essere il
      mov   ds,ax             ; null pointer
      mov   dx,ax
      mov   ax,2563h          ; l'interrupt e' il 63h
      int   21h               ; disabilitazione dell'interrupt

      mov   ax, offset isr
      mov   es,ax
      mov   ah,49h
      int   21h
      ret

;      mov   ax,4c00h          ; errorlevel=0
;      int   21h               ; fine del programma e ritorno al dos

unload      endp


; La funzione del DOS che fa divenatare questo codice un TSR deve sapere quale
; porzione di codice debba essere lascaita in memoria, e l'etichetta endisr
; serve per dire dov'e' la fine; l'inizio e l'etichetta isr.

endisr      db    00h


;-----------------------------------------------------------------------------
; Questa funzione, a cui il programma salta immediatamente dopo il caricamento
; in memoria, configura la porta seriale e installa le routine di servizio per
; l'interrupt 63.
;-----------------------------------------------------------------------------
install        proc near

;-----------------------------------------------------------------------------
; Configurazione porta seriale
;-----------------------------------------------------------------------------
      mov   cl,COM         ; ricerca indirizzo di base dell'uart della COMn
      shl   cl,1
      mov   ch,04
      mov   bp,cx
      xor   ax,ax
      mov   es,ax
      mov   ax,es:[bp]
      mov   baseaddr,ax
      mov   ax,cs
      mov   es,ax             ; ora l'inidirizzo e' in baseaddr

      mov   dx,[baseaddr]
      add   dx,3              ; LCR
      mov   al,80h            ; DLAB
      out   dx,al             ; ora si puo' scrivere sul divisor latch
      mov   dx,[baseaddr]     ; divisor latch
      mov   ax,bauddiv        ; valore da scrivere nel divisore
      out   dx,ax             ; baudrate
      mov   dx,[baseaddr]
      add   dx,3              ; LCR
      mov   al,03             ; no par, 8 bit, 1 stop
      out   dx,al
      mov   dx,[baseaddr]
      add   dx,4              ; MCR
      xor   ax,ax             ; no interrupt, no loopback
      out   dx,al


;-----------------------------------------------------------------------------
; Inizializzazioni varie
;-----------------------------------------------------------------------------

      mov   cs:azrep,RETRREP
      mov   cs:elrep,RETRREP


;-----------------------------------------------------------------------------
; Installazione isr
;-----------------------------------------------------------------------------

      mov   dx,offset isr     ; questo e' l'indirizo d'inizio delle isr
      mov   ax,2563h          ; l'interrupt e' il 63h
      int   21h               ; abilitazione dell'interrupt

      mov   dx,offset endisr  ; questo e' l'indirizzo finale delle isr
      add   dx,15             ; arrotondamento
      mov   cl,4
      shr   dx,cl             ; conversione nel numero di paragrafi da
                              ; riservare per le routine isr che
                              ; diventeranno TSR
      mov   ax,3100h
      int   21H               ; funzione DOS che fa diventare TSR (e che
                              ; ovviamente non esce...)

install     endp


_TEXT       ends


            end   start
