        name    Rotore1
        title   Driver rotore IK5NAX (sulla base del DummyKCT)
;
;  Questo programma, scritto a partire dal ROTORDUM.ASM invia sulla COM1
;  i valori relativi a azimuth e elevazione con un semplice formato:
;  <azim flag> <azim val> <elev flag> <elev val>
;  con:  <azim flag> = e0h  e  <elev flag> = eeh
;  I due valori sono divisi per due, cos  possibile trasmetterli in un solo
;  byte: la risoluzione di 2 e sufficiente
;  Provvisoriamente, per facilitare la lettura su un monitor ASCII ai due
;  valori viene aggiunto 20h.
;
;                       Prima versione messa a punto l'11/11/1995
;                       Modifiche:
;                             24/02/1996 prova con il vero rotore (solo az)
;
;

_TEXT	segment word public 'CODE'

	ORG	100h			; this is a .COM file!

	assume	cs:_TEXT, ds:_TEXT, es:_TEXT, ss:_TEXT

start:	jmp	install

enabled	db	1		; enabled=1, disabled=0
azim	dw	0		; save target az and el
elev	dw	0
oldazim dw      0               ; valori della chiamata precedente per
oldelev dw      0               ; trasmettere solo se c'e' stata una variazione
flip    db      0

COM   equ   3                 ; COM1 = 0, COM2 = 1, COM3 = 2, COM4 =3


;******************************************************************
;  Here is the interrupt service routine.
;******************************************************************

	assume	ds:nothing, es:nothing, ss:nothing

isr:	jmp	dispatch

	ORG	isr + 10
	DB	"RotorDRV"	; signature string

dispatch proc	near
	sti
	cmp	ah,0		; dispatch according to function code
	je	readstat
	cmp	ah,3
	je	readpos
	cmp	ah,4
	je	settarg
	cmp	ah,9
        je      enable
        cmp       ah,40h
        je        flipctrl
        cmp       ah,41h
        je        flipread
        iret
dispatch endp

flipctrl proc  near           ; al=0 no flip   al=1 flip
        mov flip,al
        iret
flipctrl endp

flipread proc near
         mov al,flip
         iret
flipread endp

readstat proc	near
        mov     al,0h            ; status is always good.
; se si mette al=ff allora l'Instant Track rivela che il rotore e' disabilitato
	iret
readstat endp

readpos proc    near
	mov	ax,cs:elev
	mov	cx,ax
	mov	bx,cs:azim
	mov	dx,bx
	iret
readpos	endp


enable	proc	near
	mov	enabled,al	; save the enable/disable flag.
	iret
enable	endp

;******************************************************************
; Function 04: Set Target position
; --------------------------------
; This function is used by the TSR to tell the tracker TSR where to
; point the antennas.  It is called periodically.
;
;    At Entry: AH=4
;              CX - target ELEV value in degrees (-90 to 269, signed binary)
;              DX - target AZIM value in degrees (0-359, binary)
;              Note: If either value is invalid the entire command will
;                    be ignored.
;
;    At Exit:  No parameters are returned
;*******************************************************************
; 123456789
; +000 +000
;  az   el

settarg	proc	near
	cmp	enabled,0	; don't do anything if disabled.
	je	st_exit

	mov	cs:azim,dx
	mov	cs:elev,cx
        test      cx,8000h          ;se elev<0 o elev>180 non trasmettere nulla
        jnz       st_exit
        cmp       cx,00b4h
        jg        st_exit

        sar       dx,1              ; sia azim che elev vengono divisi per
        sar       cx,1              ; due cosi' basta un byte per trasmetterli
                                    ; e la risoluzione di 2 e' sufficiente

        cmp       flip,0
        jz        save
        mov       bx,00b4h
        sub       bx,dx
        mov       dx,bx
        mov       bx,005ah
        sub       bx,cx
        mov       cx,bx

save:   cmp       cs:oldazim,dx     ; solo se almeno uno fra azim e elev e'
        jne       sendaz              ; cambiato rispetto alla chiamata
        cmp       cs:oldelev,cx     ; precedente vengono trasmessi i dati
        jne       sendel
        jmp       st_exit


sendaz:
        push      dx
        mov       cs:oldazim,dx
        mov       ax,01e0h
        mov       dx,COM
        int       14h               ; flag azim
        pop       dx
        mov       al,dl
        mov       ah,1
        mov       dx,COM
        int       14h               ; valore azim
        jmp       st_exit


sendel:
        push      cx
        mov       cs:oldelev,cx
        mov       ax,01eeh
        mov       dx,COM
        int       14h               ; flag elev
        pop       cx
        mov       al,cl
        mov       ah,1
        mov       dx,COM
        int       14h               ; valore elev

st_exit:	iret

settarg endp


lastbyte	equ	this byte	; flag for end of memory used

install	proc	near

        mov       ax,00e3h      ; 9600 n 8 1
        mov       dx,COM
        int       14h           ; setup porta seriale

	mov	dx, offset isr	; get address of service routine
	mov	ax, 2563h	; set vector 0x63
	int	21h		; set up the interrupt vector

				; reserve memory and terminate.
	mov	dx,offset lastbyte	; get last address used
	add	dx,15		; round up
	mov	cl,4
	shr	dx,cl		; convert to paragraphs
	mov	ax,3100h	; TSR function code, good status
	int	21H		; go TSR!

install	endp

_TEXT	ends

	end	start
